#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>
#include <engine>
#include <cstrike>

#include <hamsandwich>

#include <nvault>

#include <ColorChat>

#define VIP_FLAG                        ADMIN_RESERVATION

#define SCOREATTRIB_DEAD                (1 << 0) 
#define SCOREATTRIB_VIP                 (1 << 2)

#define HUD_DELAY 			0.2

#define MINIMUM_FALL_SPEED 		10
#define MAXIMUM_DAMAGE_FROM_JUMP 	70.0
#define DAMAGE 				60.0
#define DELAY 				0.20
#define ILOSC_SKILLI			21
#define ILOSC_UZYWEK			7
#define ILOSC_POZIOMOW			104
#define	ILOSC_TIMEROW			2
#define	ILOSC_DAMAGE			33
#define MAX_LEN				32
#define MAX_ARGS			4
#define IsPlayer(%1) 			(1 <= %1 <= get_maxplayers())

enum(*= 7){
	TASK_STEALTH,
	TASK_KAMUFLAZ,
	TASK_GUN,
	TASK_ZES,
	TASK_KAR,
	TASK_TRAP
};

static const 	gVersion[] 		= "1.0";
static const 	gPrefix[] 		= "[uTabalugi]";
static const 	gThunderSound[] 	= "ambience/thunder_clap.wav";
static const 	gPushSound[] 		= "misc/uTabalugi/push.wav";
static const 	gAuraModel[] 		= "models/uTabalugi/aura.mdl";
static const	gPulapkaModel[]		= "models/uTabalugi/pulapka.mdl";
static const	gPulapkaClassname[]	= "xp_pulapka";
static const 	gAuraClassname[] 	= "xp_aura";

new 		gXp[33],
		gLevel[33],
		gBonus[33],
		gPoint[33],
		gSkill[33][ILOSC_SKILLI],
		gUsed[33][ILOSC_UZYWEK],
		gBindKey[33][MAX_ARGS],
		gBindKeyA[33][MAX_ARGS],
		gBindKeyS[33][MAX_ARGS],
		gBindKeyK[33][MAX_ARGS],
		gBindKeyP[33][MAX_ARGS],
		gBindKeyPL[33][MAX_ARGS],
		gBindKeyOS[33][MAX_ARGS];
		//gCamouflageOldModel[33][MAX_LEN];

new bool:	gCantMove[33];
		
		new		Float:gfDamage[33][ILOSC_DAMAGE],
		Float:gfOrigin[3],
		Float:gfTime[33][ILOSC_TIMEROW];

new		gStatusMsg,
		gArmorMsg,
		gScreenFadeMsg,
		gScreenShakeMsg,
		gVaultFile,
		//gMaxPlayers,
		
		sprite_blood,
		sprite_bloodspray,
		sprite_lightning,
		sprite_smoke,
		sprite_push;
		
new g_end;

new const gStealth[6]={
	7,
	8,
	9,
	11,
	17,
	0
};

new g_MsgScoreAttrib = 0;	

/*TABELA XP*/
new const gTable[ILOSC_POZIOMOW] = {
	100,    // 1
	200,    // 2
	500,    // 3
	1100,    // 4
	1800,    // 5
	2700,    // 6
	3700,    // 7
	4800,    // 8
	5900,    // 9
	7200,    // 10
	8600,	//11
	10100,//12
	11600, //13
	13400, //14
	15300,//15
	17300,//16
	19400,//17
	21600,//18
	23800,//19
	26100,//20
	28500,//21
	31000, //22
	33600,//23
	36200,//24
	38900,//25
	41600,//26
	44400,//27
	47300,//28
	50300,//29
	53400,//30
	56600,//31
	59900,//32
	63300,//33
	66800,//34
	70400,//35
	74100,//36
	77800,//37
	81600,//38
	85500,//39
	89500,//40
	93600,//41
	97800,//42
	102100,//43
	106400,//44
	110800,//45
	115300,//46
	119800,//47
	124400,//48
	129000,//49
	133700,//50
	138500,//51
	143400,//52
	148400,//53
	153500,//54
	158700,//55
	164000,//56
	169400,//57
	174900,//58
	180500,//59
	186200,//60
	192000,//61
	197800,//62
	203700,//63
	209700,//64
	215800,//65
	222000,//66
	228300,//67
	234800,//68
	241400,//69
	248100,//70
	254800,//71
	261600,//72
	268500,//73
	275500,//74
	282600,//75
	289800,//76
	297000,//77
	304300,//78
	311700,//79
	319200,//80
	326800,//81
	334500,//82
	342300,//83
	351500,//84
	365000,//85
	378000,//86
	388000,//87
	400000,//88
	409000,//89
	418100,//90
	427300,//91
	436600,//92
	446000,//93
	455500,//94
	465100,//95
	474700,//96
	484400,//97
	494200,//98
	504100,//99
	514100,//100
	526000,//101
	532000,//102
	541000,//103
	555000//104
};
/*enum OBJECTTYPE{
	OBJECT_GENERIC,
	OBJECT_PLAYER,
	OBJECT_ARMOURY
};*/

/*WYWOLYWANE NA POCZATKU MAPY*/
public plugin_init() {
	register_plugin("ExpMod", gVersion, "Diablix & BurN");
	
	gStatusMsg 	= get_user_msgid("StatusText");
	gArmorMsg  	= get_user_msgid("ArmorType");
	gScreenFadeMsg 	= get_user_msgid("ScreenFade");
	gScreenShakeMsg = get_user_msgid("ScreenShake");
	g_MsgScoreAttrib = get_user_msgid("ScoreAttrib");
	//gMaxPlayers	= get_maxplayers();
	
	register_forward(FM_EmitSound, "FW_FM_Sound") 
	register_forward(FM_Touch, "FW_FM_Touch");
	register_forward(FM_PlayerPreThink, "FW_FM_Prethink");
	register_forward(FM_SetModel,"FW_FM_Setmodel");
	register_think(gAuraClassname, "FW_FM_AuraThink");
	register_event("DeathMsg", "eventDeath", "a");
	//register_event("Damage", 			"eventHeDamage", "b", "2!0", "4!0", "5!0", "6!0"		);
	register_event("CurWeapon", "eventCurWeapon", "be","1=1");
	register_logevent("eventRoundstart",2,"1=Round_Start");
	register_logevent("the_end", 2, "1=Round_End");
	RegisterHam(Ham_Spawn, 	"player", "eventPlayerSpawn",  1	);
	RegisterHam(Ham_TakeDamage, "player", "eventDamage", 0);
	set_task(HUD_DELAY, "writeHud",0, "", 0, "b");
	set_task(0.1, "showIt",0, "", 0, "b");
	register_clcmd("say /reset", "doReset");
	register_clcmd("say_team /reset", "doReset");
	register_clcmd("say /xp", "openMenu");
	register_clcmd("say_team /xp", "openMenu");
	register_clcmd("say /exp", "openMenu");
	register_clcmd("say_team /exp", "openMenu");
	register_clcmd("say /top15exp", "cmdShowTop15");
	register_clcmd("say_team /top15exp", "cmdShowTop15");
	register_clcmd( "say /vips", "cmdShowVipsOnline" );
	register_clcmd( "say vips", "cmdShowVipsOnline" );
	register_clcmd( "say /vipy", "cmdShowVipsOnline" );
	register_clcmd( "say vipy", "cmdShowVipsOnline" );
	register_clcmd( "say /vip", "cmdShowVipsOnline" );
	register_clcmd( "say vip", "cmdShowVipsOnline" );
	register_clcmd("+skill", "doThunder");
	register_clcmd("+skill2", "doAura");
	register_clcmd("+skill3", "doStealth");
	register_clcmd("+skill4", "doKamuflaz");
	register_clcmd("+skill5", "doPush");
	register_clcmd("+skill6", "doTrap");
	register_clcmd("+skill7", "doBlind");
	register_clcmd("Zbinduj_Blyskawice_Na", "cmdBind");
	register_clcmd("Zbinduj_Aure_Na", "cmdBindA");
	register_clcmd("Zbinduj_Niewidzialnosc_Na", "cmdBindST");
	register_clcmd("Zbinduj_Kamuflaz_Na", "cmdBindK");
	register_clcmd("Zbinduj_Odepchniecie_Na", "cmdBindP");
	register_clcmd("Zbinduj_Pulapke_Na", "cmdBindPL");
	register_clcmd("Zbinduj_Oslepienie_Na", "cmdBindOS");
	register_menucmd(register_menuid("MainMenu"), 1023, "handleMainMenu");
	register_menucmd(register_menuid("SkillMenu"), 1023, "handleSkillMenu");
	register_menucmd(register_menuid("Skill2Menu"), 1023, "handleSkill2Menu");
	register_menucmd(register_menuid("Skill3Menu"), 1023, "handleSkill3Menu");
	register_menucmd(register_menuid("HPMenu"), 1023, "handleHPMenu");
	register_menucmd(register_menuid("APMenu"), 1023, "handleAPMenu");
	register_menucmd(register_menuid("KRMenu"), 1023, "handleKRMenu");
	register_menucmd(register_menuid("RSMenu"), 1023, "handleRSMenu");
	register_menucmd(register_menuid("PRMenu"), 1023, "handlePRMenu");
	register_menucmd(register_menuid("SSMenu"), 1023, "handleSSMenu");
	register_menucmd(register_menuid("ARMenu"), 1023, "handleARMenu");
	register_menucmd(register_menuid("STMenu"), 1023, "handleSTMenu");
	register_menucmd(register_menuid("KMMenu"), 1023, "handleKMMenu");
	register_menucmd(register_menuid("PSMenu"), 1023, "handlePSMenu");
	register_menucmd(register_menuid("SGMenu"), 1023, "handleSGMenu");
	register_menucmd(register_menuid("PHMenu"), 1023, "handlePHMenu");
	register_menucmd(register_menuid("XPMenu"), 1023, "handleXPMenu");
	register_menucmd(register_menuid("BRMenu"), 1023, "handleBRMenu");
	register_menucmd(register_menuid("OBMenu"), 1023, "handleOBMenu");
	register_menucmd(register_menuid("MGMenu"), 1023, "handleMGMenu");
	register_menucmd(register_menuid("KSMenu"), 1023, "handleKSMenu");
	register_menucmd(register_menuid("PLMenu"), 1023, "handlePLMenu");
	register_menucmd(register_menuid("ZSMenu"), 1023, "handleZSMenu");
	register_menucmd(register_menuid("OSMenu"), 1023, "handleOSMenu");
	register_menucmd(register_menuid("WZMenu"), 1023, "handleWZMenu");
	register_concmd("mm_dodaj", "cmdDodajKase", ADMIN_IMMUNITY, "<nick> <ilosc kasy>"); 
	gVaultFile   	= 	nvault_open("ExpMod");
	
	register_message(get_user_msgid("SayText"), "message");
	register_message(g_MsgScoreAttrib, "messageScoreAttrib");
	
	set_task(90.0, "NajlepszyGracz", 0, "", _, "b");
	
}

public plugin_natives()
{
	register_library("hns_xp");
	register_native("hnsxp_get_user_xp", "_get_xp");
	register_native("hnsxp_set_user_xp", "_set_xp");
}

public the_end() {
	g_end=1;
}

public cmdDodajKase(id, level, cid){ 
	if(!cmd_access(id, level, cid, 3)) 
		return 1; 
	
	new target[32], amount[21], reason[21]; 
	
	read_argv(1, target, 31); 
	read_argv(2, amount, 20); 
	read_argv(3, reason, 20); 
	
	new player = cmd_target(id, target, 8); 
	
	if(!player)  
		return 1; 
	
	new vIloscKasy = str_to_num(amount); 
	
	gXp[player] += vIloscKasy; 
	
	Save(player);
	
	return 0;
}

public eventDamage(victim, inflicter, attacker, Float:fDamage, bitDamage)
{
	if(!is_user_alive(victim) || !is_user_connected(victim) || !is_user_connected(attacker))
		return HAM_IGNORED;
	
	if(gSkill[attacker][16]){
		if(get_user_weapon(attacker) == CSW_KNIFE){
			SetHamParamFloat(4, fDamage + float((gSkill[attacker][16] * 2) + gSkill[attacker][19]));
		}
	}
	if(gSkill[victim][13]){
		if(IsPlayer(attacker)){
			new random = random_num(1, 100);
			
			if(random <= (gSkill[victim][13] * 3)){
				new szName[32];
				get_user_name(attacker, szName, sizeof szName - 1);
				
				SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)));
				ExecuteHam(Ham_TakeDamage, attacker, "", victim/*id*/, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)), 1);
				set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 3.0, 3.2, 1.1, 1.1, 1);
				show_hudmessage(victim, "[uTabalugi] Lustrzane odbicie : Przyjales mniejsze obrazenia [%.1f zamiast %.1f]^n%s Przyjal [%.1f] obrazen na siebie!", fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)), fDamage, szName, fDamage * (1.0 - (float(gSkill[victim][13]) / 10.0)));
			}
		}
	}
	
	if(gSkill[victim][14]){
		if(bitDamage & DMG_FALL){
			SetHamParamFloat(4, fDamage * (1.0 - (float(gSkill[victim][14]) / 10.0)));
		}
	}
	
	return HAM_IGNORED;
}

public removeStuck(id){
	id -= TASK_TRAP;
	
	if(!is_user_alive(id)) return 1;
	
	gCantMove[id] = false;
	set_pev(id, pev_maxspeed, 250.0);
	set_pev(id, pev_gravity, 1.0);
	
	set_task(0.2, "eventCurWeapon", id);
	
	return 0;
}

public plugin_end(){
	new iPlayers[32], iNum;
	get_players(iPlayers, iNum);
	
	for(new i=0;i<iNum;i++){
		Save(iPlayers[i]);
	}
}

public eventRoundstart(){
	
	g_end=0;
	new ent = -1;
	while((ent = fm_find_ent_by_class(ent, gAuraClassname)))
	{
		engfunc(EngFunc_RemoveEntity, ent);
		
	}
}

public plugin_precache(){
	sprite_blood = 		engfunc(EngFunc_PrecacheModel, "sprites/blood.spr");
	sprite_bloodspray =	engfunc(EngFunc_PrecacheModel, "sprites/bloodspray.spr");
	sprite_lightning = 	engfunc(EngFunc_PrecacheModel, "sprites/lgtning.spr");
	sprite_smoke = 		engfunc(EngFunc_PrecacheModel, "sprites/steam1.spr");
	sprite_push =		engfunc(EngFunc_PrecacheModel, "sprites/shockwave.spr");
	
	engfunc(EngFunc_PrecacheSound, gPushSound);
	engfunc(EngFunc_PrecacheSound, gThunderSound);
	
	engfunc(EngFunc_PrecacheModel, gPulapkaModel);
	engfunc(EngFunc_PrecacheModel, gAuraModel);
}
/*KONIEC WYWOLYWANYCH NA POCZATKU MAPY*/
/*FORWARDY*/
public FW_FM_Touch(toucher, touched, entity, id){
	if(!is_user_alive(toucher) || !is_user_alive(touched)) 
		return;
	
	new touched_origin[3], toucher_origin[3];
	get_user_origin(touched, touched_origin); 
	get_user_origin(toucher, toucher_origin);
	new Float:toucher_minsize[3], Float:touched_minsize[3];
	pev(toucher, pev_mins, toucher_minsize);
	pev(touched, pev_mins, touched_minsize);
	
	if(touched_minsize[2] != -18.0) {
		if(!(toucher_origin[2] == touched_origin[2]+72 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+54 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	else {
		if(!(toucher_origin[2] == touched_origin[2]+68 && toucher_minsize[2] != -18.0) && !(toucher_origin[2] == touched_origin[2]+50 && toucher_minsize[2] == -18.0)){
			return;
		}
	}
	
	new flags = entity_get_int(touched, EV_INT_flags);
	
	if (flags & FL_ONGROUND){
		if(is_user_alive(touched) && gfDamage[toucher][touched] <= get_gametime()){
			gfDamage[toucher][touched] = get_gametime() + DELAY;
			smashHead(touched, toucher, DAMAGE - float((gSkill[touched][9] * 7)));
		}
	}
}

public FW_FM_Prethink(id){
	static button, oldbutton;
	button =	pev(id, pev_button);
	oldbutton =	pev(id, pev_oldbuttons);
	
	if((button & IN_RELOAD) && !(oldbutton & IN_RELOAD)){
		WyswietlSSMenu(id);
	}
	
	if(!gSkill[id][2]) return 1;
	if(get_user_team(id) != 2) return 1;
	
	set_pev(id, pev_flTimeStepSound, 999);
	
	return 0;
}
/*KONIEC FORWARDOW*/
/*EVENTY*/
public eventPlayerSpawn(id){
	gUsed[id][0] = false;
	gUsed[id][1] = false;
	gUsed[id][2] = false;
	gUsed[id][3] = false;
	gUsed[id][4] = false;
	gUsed[id][5] = false;
	gUsed[id][6] = false;
	
	if(!is_user_alive(id)) return 1;
	set_pev(id, pev_health, float(100 + ((gSkill[id][0] * 10) + gSkill[id][20])));
	fm_add_user_armor(id, float((gSkill[id][1] * 20) + (gSkill[id][20] * 5)), 2);
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 0);
	
	if(task_exists(id + TASK_GUN)) remove_task(id + TASK_GUN);
	if(task_exists(id + TASK_KAR)) remove_task(id + TASK_KAR);
	if(task_exists(id + TASK_ZES)) remove_task(id + TASK_ZES);
	
	if(get_user_team(id) == 2)
	gCantMove[id] = false;
	set_task(10.1, "tryGun", id + TASK_GUN, _, _, "a", 1);
	set_task(10.2, "tryKar", id + TASK_KAR, _, _, "a", 1);
	set_task(10.4, "tryZes", id + TASK_ZES, _, _, "a", 1);
	return 0;
}

public eventDeath(){ 
	new attacker 	= read_data(1); 
	new victim 	= read_data(2);
	
	new bool:bHasAccess = bool:(get_user_flags(attacker) & ADMIN_RESERVATION);
	new exp_to_give;
	
	if(IsPlayer(attacker)){	
		if(get_user_team(attacker) != get_user_team(victim)){
			gBonus[attacker] = 0;
			
			exp_to_give = 10;
			
			if(gLevel[victim] >= (gLevel[attacker] + 25)) 					{ gBonus[attacker] = 25; exp_to_give += 20; }
			if(!gBonus[attacker] && gLevel[victim] >= (gLevel[attacker] + 5)) 		{ gBonus[attacker] = 5;exp_to_give += 10; }
			if(bHasAccess) 									{ exp_to_give += 5; }
			
			if(gSkill[attacker][11] >= 5)
				exp_to_give += (gSkill[attacker][11] / 5);
			
			addExp(attacker, exp_to_give);
			
			ColorChat(attacker, GREEN, "%s^x01 Dostales^x03 %d XP^x01 za%s%s%s", gPrefix, exp_to_give, gBonus[attacker] == 0 ? " zabicie" : "", gBonus[attacker] == 5 ? " zabicie gracza lepszego o minimum 5 poziomow" : "", gBonus[attacker] == 25 ? " zabicie gracza lepszego o minimum 25 poziomow" : "");
			
			gBonus[attacker] = 0;
		}
	}
	set_task(1.0, "removeEff", victim);
	if(task_exists(victim + TASK_STEALTH)) remove_task(victim + TASK_STEALTH);
	if(task_exists(victim + TASK_GUN)) remove_task(victim + TASK_GUN);
	
	trySpawn(victim);
}

public removeEff(victim) set_pev(victim, pev_effects, EF_NODRAW);

public eventCurWeapon(id){
	if(!is_user_alive(id))
		return 0;
	
	if(gCantMove[id]){
		set_pev(id, pev_maxspeed, 0.1);
		set_pev(id, pev_gravity, 3.0);
	}
	
	return 0;
}

public client_connect(id){
	gBonus[id] = 0;
	Load(id);
}

public client_disconnect(id)
{
	Save(id);
}

/*KONIEC EVENTOW*/
/*MENU*/
public WyswietlMainMenu(id) 
{
	new MenuBody[150], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod^n");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wMenu umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZresetuj umiejetnosci");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wTop15 ExpMod");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r4. \wOdswiez");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MainMenu");
}

public handleMainMenu(id, key){
	switch(key + 1){
		case 1: WyswietlSkillMenu(id);
		case 2: { doReset(id); WyswietlMainMenu(id); }
		case 3: { cmdShowTop15(id); }
		case 4: { refreshExp(id); ColorChat(id, GREEN, "%s^x01 Odswiezyles exp", gPrefix); WyswietlMainMenu(id); }
	}
	
	return 1;
}

public WyswietlSSMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\r -\y Uzyj umiejetnosc");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. %sBlyskawica\w [Zada\y %d %% Aktualnego HP\w]\r|\w[Uzyta : %s\w]", gSkill[id][4] ? "\w" : "\d", gSkill[id][4] * 8, gUsed[id][0] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. %sAura zycia\w [\y%dHP\r/\ysek\w przez\y %d sekund\w]\r|\w[Uzyta : %s\w]", gSkill[id][5] ? "\w" : "\d", gSkill[id][5] * 5, gSkill[id][5] * 5, gUsed[id][1] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. %sNiewidzialnosc\w [Na\y %d sek\w]\r|\w[Uzyta : %s\w]", gSkill[id][6] ? "\w" : "\d", gSkill[id][6] * 2, gUsed[id][2] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. %sKamuflaz\w [Na\y %d sek\w]\r|\w[Uzyty : %s\w]", gSkill[id][7] ? "\w" : "\d", gSkill[id][7] * 5, gUsed[id][3] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. %sOdepchniecie\w [Z moca\y %d unitow\w]\r|\w[Uzyte : %s\w]", gSkill[id][10] ? "\w" : "\d", gSkill[id][10] * 20, gUsed[id][4] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. %sPostaw pulapke\r|\w[Postawiona : %s\w]", gSkill[id][17] ? "\w" : "\d", gUsed[id][5] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. %sOslepienie\w [Na\y %d sek\w]\r|\w[Uzyte : %s\w]", gSkill[id][19] ? "\w" : "\d", gSkill[id][19], gUsed[id][6] ? "\rTak" : "\yNie");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wWyjscie");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SSMenu");
}

public handleSSMenu(id, key){
	switch(key + 1){
		case 1:{
			doThunder(id);
		}
		case 2:{
			doAura(id);
		}
		case 3:{
			doStealth(id); 
		}
		case 4:{
			doKamuflaz(id);
		}
		case 5:{
			doPush(id);
		}
		case 6:{
			doTrap(id);
		}
		case 7:{
			doBlind(id);
		}
	}
	return 1;
}

public WyswietlSkill3Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\r -\y Menu umiejetnosci #3");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wLepszy noz [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wPulapka [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wZestaw broni [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wOslepienie [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wWzmocnienie [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill3Menu");
}

public handleSkill3Menu(id, key){
	switch(key + 1){
		case 1:{
			WyswietlKSMenu(id);
		}
		case 2:{
			WyswietlPLMenu(id);
		}
		case 3:{
			WyswietlZSMenu(id);
		}
		case 4:{
			WyswietlOSMenu(id);
		}
		case 5:{
			WyswietlWZMenu(id);
		}
		case 10:{
			WyswietlSkill2Menu(id);
		}
	}
	
	return 1;
}

public WyswietlSkill2Menu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\r -\y Menu umiejetnosci #2");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wPistolety [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wStalowa glowa [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wOdepchniecie [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wDodatkowy exp [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wLustrzane odbicie [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wGumowe buty [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wKarabiny [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "Skill2Menu");
}

public handleSkill2Menu(id, key){
	switch(key + 1){
		case 1:{
			WyswietlPSMenu(id);
		}
		case 2:{
			WyswietlSGMenu(id);
		}
		case 3:{
			WyswietlPHMenu(id);
		}
		case 4:{
			WyswietlXPMenu(id);
		}
		case 5:{
			WyswietlBRMenu(id);
		}
		case 6:{
			WyswietlOBMenu(id);
		}
		case 7:{
			WyswietlMGMenu(id);
		}
		case 9:{
			WyswietlSkill3Menu(id);
		}
		case 10:{
			WyswietlSkillMenu(id);
		}
	}
	
	return 1;
}

public WyswietlSkillMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\r -\y Menu umiejetnosci #1");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r1. \wWitalnosc [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wPancerz [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r3. \wCiche kroki [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r4. \wOdrodzenie [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r5. \wBlyskawica [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r6. \wAura zycia [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r7. \wKamuflaz [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r8. \wNiewidzialnosc\w [\yPrzejdz do menu\w]");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r9. \wDalej");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SkillMenu");
}

public handleSkillMenu(id, key){
	switch(key + 1){
		case 1:{
			WyswietlHPMenu(id);
		}
		case 2:{
			WyswietlAPMenu(id);
		}
		case 3:{
			WyswietlKRMenu(id);
		}
		case 4:{
			WyswietlRSMenu(id);
		}
		case 5:{
			WyswietlPRMenu(id);
		}
		case 6:{
			WyswietlARMenu(id);
		}
		case 7:{
			WyswietlKMMenu(id);
		}
		case 8:{
			WyswietlSTMenu(id);
		}
		case 9:{
			WyswietlSkill2Menu(id);
		}
		case 10:{
			WyswietlMainMenu(id);
		}
	}
	
	return 1;
}

public WyswietlPLMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Mozesz polozyc niewidzialna pulapke, gdy przeciwnik w nia wejdzie, utknie na 3 sekundy\w^nWymagany poziom :\y 15\w^n^nWykupione - [%s\w]^n^nPunkty umiejetnosci: \y%d\r /\y 1\w", gSkill[id][17] ? "\yTak" : "\rNie", gSkill[id][17]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyPL[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PLMenu");
}

public handlePLMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][17]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gLevel[id] < 15){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (15 wymagany)", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][17] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Pulapke^x01 !", gPrefix);
				WyswietlPLMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Pulapke_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkill3Menu(id);
		}
	
	return 1;
}

public pfn_touch(id, ent){
	if(is_user_alive(id)){
		new szClassName[32], vOrigin[3];
		get_user_origin(id, vOrigin);
		
		entity_get_string(ent, EV_SZ_classname, szClassName, 31);
		new owner = pev(ent, pev_owner);
		
		if(equal(szClassName, gPulapkaClassname)){
			if(get_user_team(owner) != get_user_team(id)){
				gCantMove[id] = true;
				set_pev(id, pev_maxspeed, 0.1);
				set_pev(id, pev_gravity, 3.0);
				Smoke(vOrigin, 20, 20);
				
				message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
				write_byte(TE_IMPLOSION);
				write_coord(vOrigin[0]);
				write_coord(vOrigin[1]);
				write_coord(vOrigin[2]);
				write_byte(80);
				write_byte(10);
				write_byte(10); 
				message_end();
				
				set_task(0.2, "eventCurWeapon", id);
				set_task(3.1, "removeStuck", id + TASK_TRAP, _, _, "a", 1);
				
				engfunc(EngFunc_RemoveEntity, ent);
			}
		}
	}
}

public doTrap(id){
	if(!gSkill[id][17]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][5]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:fOrigin[3], ent;
	entity_get_vector(id, EV_VEC_origin, fOrigin);
	
	ent = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"));
	
	set_pev(ent, pev_classname, gPulapkaClassname);
	set_pev(ent, pev_owner, id);
	set_pev(ent, pev_movetype, MOVETYPE_TOSS);
	set_pev(ent, pev_origin, fOrigin);
	set_pev(ent, pev_solid, SOLID_BBOX);
	
	engfunc(EngFunc_SetModel, ent, gPulapkaModel);
	engfunc(EngFunc_SetSize, ent, Float:{-16.0, -16.0, 0.0}, Float:{16.0, 16.0, 2.0});
	
	drop_to_floor(ent);
	
	set_rendering(ent, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 64);
	
	//client_cmd(id, "spk fvox/blip");
	
	set_hudmessage(0, 255, 8, 0.01, 0.54, 0, 4.1, 4.2, 2.1, 1.1, 2);
	show_hudmessage(id, "^n^n[uTabalugi] Postawiles pulapke!");
	ColorChat(id, GREEN, "%s^x01 Pulapka Bedzie Stala Przez 10 Sekund!", gPrefix);
	set_task(10.0,"usunent",ent);
	
	gUsed[id][5] = true;
	
	return 0;
}

public WyswietlKRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Nie slychac twoich krokow\w^n^nWykupione - [%s\w]^n^nPunkty umiejetnosci: \y%d\r /\y 1\w", gSkill[id][2] ? "\yTak" : "\rNie", gSkill[id][2]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KRMenu");
}

public handleKRMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][2]){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][2] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Wykupiles^x03 Ciche kroki^x01 !", gPrefix);
				WyswietlKRMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public doThunder(id){
	if(!gSkill[id][4]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][0]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][0] = true;
		new num;
		new vorigin[3], pos[3];
		get_user_origin(target, vorigin);
		
		vorigin[2] -= 26;
		pos[0] = vorigin[0] + 150;
		pos[1] = vorigin[1] + 150;
		pos[2] = vorigin[2] + 800;
		
		Thunder(pos, vorigin);
		Smoke(vorigin, 10, 10);
		
		switch(gSkill[id][4]){
			case 1: num = (get_user_health(target) / 10)
				case 2: num = (get_user_health(target) / 8)
				case 3: num = (get_user_health(target) / 6)
				case 4: num = (get_user_health(target) / 4)
				case 5: num = (get_user_health(target) / 2)
			}
		
		ExecuteHam(Ham_TakeDamage, target, "", id, float(num), 1);	
	}
	return 0;
}

public doBlind(id){
	if(!gSkill[id][19]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][6]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new target, body;
	get_user_aiming(id, target, body);
	
	if(IsPlayer(target) && get_user_team(target) != get_user_team(id)){
		gUsed[id][6] = true;
		makeScreenFade(target, float(gSkill[id][19]), float(gSkill[id][19]) + 0.3, 0, 0, 0, 255);
		
		set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 1.1, 1.2, 1.5, 1.5, 2);
		show_hudmessage(id, "^n[uTabalugi] Oslepiles przeciwnika na %d sekund%s!", gSkill[id][19], gSkill[id][19] == 1 ? "e" : "y");	
	}
	return 0;
}

public WyswietlBRMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Masz szanse na bariere ktora odbije %% zadanych Tobie obrazen\w^nWymagany poziom :\y 5\w^n^nAktualna szansa - [\y%d%%\w]^nAktualnie odbije - [\y%d%%\w]^nSzansa po dodaniu punktu - [\y%d%%\w]^nPo dodaniu punktu odbije - [\y%d%% Obr\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", gSkill[id][13] * 3, gSkill[id][13] * 10, (gSkill[id][13] + 1) * 3, (gSkill[id][13] + 1) * 10, gSkill[id][13]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "BRMenu");
}

public handleBRMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][13] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlBRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][13] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na Odbijajaca bariere wynosi teraz^x03 %d %%^x01 i odbija^x03 %d %% obrazen", gPrefix, gSkill[id][13] * 3, gSkill[id][13] * 10);
				WyswietlBRMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlOBMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Gumowe buty redukuja Twoje obrazenia po upadku\w^n^nAktualnie redukuja - [\y%d%%\w]^nPo dodaniu punktu beda redukowac - [\y%d%%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", gSkill[id][14] * 5, (gSkill[id][14] + 1) * 5, gSkill[id][14]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OBMenu");
}

public handleOBMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][14] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOBMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][14] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje gumowe buty redukuja teraz^x03 %d %%^x01 obrazen po upadku", gPrefix, gSkill[id][14] * 5);
				WyswietlOBMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlXPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y co 5 dodanych punktow zyskujesz dodatkowy za zabicie 1XP \w^nWymagany poziom :\y 5\w^n^nAktualnie - [Dodatkow%s\y %dXP\w]^nPo dodaniu 5 punktow - [Dodatkow%s\y %dXP\w]^n^nPunkty umiejetnosci: \y%d\r /\y 20\w", gSkill[id][11] >= 5 ? "y" : "e", gSkill[id][11] / 5, gSkill[id][11] >= 5 ? "y" : "e", (gSkill[id][11] + 5) / 5, gSkill[id][11]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "XPMenu");
}

public handleXPMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][11] >= 20){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlXPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][11] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj dodatkowy exp jest teraz na poziomie^x03 %d", gPrefix, gSkill[id][11]);
				WyswietlXPMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlKMMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Po uzyciu wygladasz jak przeciwnik\w^nWymagany poziom :\y 2\w^n^nAktualnie - [Przez\y %d sekund\w]^nPo dodaniu punktu - [Przez\y %d sekund\w]^n^nPunkty umiejetnosci: \y%d\r /\y 4\w", gSkill[id][7] * 5, (gSkill[id][7] + 1) * 5, gSkill[id][7]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyK[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KMMenu");
}

public handleKMMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][7] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gLevel[id] < 2){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (2 wymagany)", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKMMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][7] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj kamuflaz trwa teraz^x03 %d sekund", gPrefix, gSkill[id][7] * 5);
				WyswietlKMMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Kamuflaz_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlSTMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Po uzyciu stajesz sie niewidzialny\w^nWymagany poziom :\y %d\w^n^nAktualnie - [\y%d sekund\w]^nPo dodaniu punktu - [\y%d sekund\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w",gStealth[gSkill[id][6]], gSkill[id][6] * 2, (gSkill[id][6] + 1) * 2, gSkill[id][6]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyS[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "STMenu");
}

public handleSTMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][6] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gLevel[id] < gStealth[gSkill[id][6]]){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (%d wymagany)", gPrefix, gStealth[gSkill[id][6]]);
				WyswietlSTMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSTMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][6] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja niewidzialnosc trwa teraz^x03 %d sekund", gPrefix, gSkill[id][6] * 2);
				WyswietlSTMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Niewidzialnosc_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlRSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Masz szanse na odrodzenie po smierci\w^nWymagany poziom :\y 5\w^n^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 3\w", gSkill[id][3] * 4, (gSkill[id][3] + 1) * 4, gSkill[id][3]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "RSMenu");
}

public handleRSMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][3] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlRSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][3] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na odrodzenie wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][3] - 1) * 4, gSkill[id][3] * 4);
				WyswietlRSMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlPHMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Gdy uzyjesz tej umiejetnosci przeciwnicy w zasiegu zostana odepchnieci\w^nWymagany poziom :\y 40\w^n^n");
	len += format(MenuBody[len], sizeof MenuBody -1, "Aktualny zasieg dzialania - [\y%d untiow\w]^nAktualna sila odepchniecia - [\y%d unitow\w]^nZasieg dzialania po dodaniu punktu - [\y%d untiow\w]^nSila odepchniecia po dodaniu punktu - [\y%d unitow\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", 20 * gSkill[id][10], 40 * gSkill[id][10], 20 * (gSkill[id][10] + 1), 40 * (gSkill[id][10] + 1), gSkill[id][10]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyP[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PHMenu");
}

public handlePHMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][10] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			if(gLevel[id] < 40){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (40 wymagany)", gPrefix);
				WyswietlPHMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][10] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz Twoje odepchniecie zadziala z zasiegu^x03 %d unitow^x01 oraz odrzuci z sila^x03 %d unitow", gPrefix, 40 * gSkill[id][10], 20 * gSkill[id][10]);
				WyswietlPHMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Odepchniecie_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlSGMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Redukuje obrazenia gdy ktos stoi Ci na glowie\w^n^nStandardowo tracisz - [\y%dHP\w]^nAktuaie tracisz - [\y%dHP\w]^nPo dodaniu punktu bedziesz tracic - [\y%dHP\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", floatround(DAMAGE), floatround(DAMAGE - (gSkill[id][9] * 7)), floatround(DAMAGE - ((gSkill[id][9] + 1) * 7)), gSkill[id][9]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "SGMenu");
}

public handleSGMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][9] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlSGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][9] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Teraz Twoja stalowa glowa obniza obrazenia o^x03 %dHP", gPrefix, floatround(DAMAGE - ((gSkill[id][9] - 1) * 7)));
				WyswietlSGMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlZSMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Masz szanse na dostanie zestawu broni\w^nUwaga -\y Aby to wykupic musisz posiadac karabiny na maks. poziomie!\w^n^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 3\w", gSkill[id][18] * 5, (gSkill[id][18] + 1) * 5, gSkill[id][18]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ZSMenu");
}

public handleZSMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][15] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Karabiny aby to ulepszyc!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gSkill[id][18] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlZSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][18] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na zestaw wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][18] - 1) * 5, gSkill[id][18] * 5);
				WyswietlZSMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill3Menu(id);
		}
	
	return 1;
}

public WyswietlMGMenu(id) 
{
	new MenuBody[768], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Masz szanse na dostanie losowego karabinu\w^nUwaga -\y Aby to wykupic musisz posiadac pistolety na maks. poziomie!\w^n^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 3\w", gSkill[id][15] * 5, (gSkill[id][15] + 1) * 5, gSkill[id][15]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "MGMenu");
}

public handleMGMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][8] != 3){
				ColorChat(id, GREEN, "%s^x01 Musisz miec maksymalny poziom Pistoletow aby to ulepszyc!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gSkill[id][15] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlMGMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][15] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na karabin wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][15] - 1) * 5, gSkill[id][15] * 5);
				WyswietlMGMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlWZMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Kazdy punkt dodany w wzmocnienie wzmacnia Twoje inne umiejetnosci\w^nWymagany poziom :\y 3\w^n^nAktualnie wzmacnia - [\y%d%%\w]^nPo dodaniu punktu bedzie wzmacniac - [\y%d%%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", gSkill[id][20] * 4, (gSkill[id][20] + 1) * 4, gSkill[id][20]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "WZMenu");
}

public handleWZMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][20] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gLevel[id] < 3){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (3 wymagany)", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlWZMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][20] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje wzmocnienie zostalo ulepszone na^x03 %d poziom", gPrefix, gSkill[id][20]);
				WyswietlWZMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill3Menu(id);
		}
	
	return 1;
}

public WyswietlOSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Mozesz oslepic nakierowanego przeciwnika\w^nWymagany poziom :\y 5\w^n^nAktualnie oslepia na - [\y%ds\w]^nPo dodaniu punktu bedzie oslepiac na - [\y%ds\w]^n^nPunkty umiejetnosci: \y%d\r /\y 4\w", gSkill[id][19], gSkill[id][19] + 1, gSkill[id][19]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyOS[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "OSMenu");
}

public handleOSMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][19] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			if(gLevel[id] < 5){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (5 wymagany)", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlOSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][19] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje oslepienie dziala teraz na^x03 %d sekund%s", gPrefix, gSkill[id][19], gSkill[id][19] == 1 ? "e" : "y");
				WyswietlOSMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Oslepienie_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkill3Menu(id);
		}
	
	return 1;
}

public WyswietlKSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Twoj noz zadaje dodatkowe obrazenia\w^nWymagany poziom :\y 9\w^n^nAktualne dodatkowe obrazenia - [\y%d\w]^nDodatkowe obrazenia po dodaniu punktu - [\y%d\w]^n^nPunkty umiejetnosci: \y%d\r /\y 10\w", gSkill[id][16] * 2, (gSkill[id][16] + 1) * 2, gSkill[id][16]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "KSMenu");
}

public handleKSMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][16] >= 10){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gLevel[id] < 9){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (9 wymagany)", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlKSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][16] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje dodatkowe obrazenia z noza wynosza teraz^x03 %d", gPrefix, gSkill[id][16] * 2);
				WyswietlKSMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill3Menu(id);
		}
	
	return 1;
}

public WyswietlPSMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Masz szanse na dostanie losowego pistoletu\w^n^nAktualna szansa - [\y%d %%\w]^nSzansa po dodaniu punktu - [\y%d %%\w]^n^nPunkty umiejetnosci: \y%d\r /\y 3\w", gSkill[id][8] * 5, (gSkill[id][8] + 1) * 5, gSkill[id][8]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PSMenu");
}

public handlePSMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][8] >= 3){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPSMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][8] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja szansa na pistolet wzrosla z^x03 %d %%^x01 na ^x03 %d %%", gPrefix, (gSkill[id][8] - 1) * 5, gSkill[id][8] * 5);
				WyswietlPSMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkill2Menu(id);
		}
	
	return 1;
}

public WyswietlARMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Mozesz postawic aure zycia ktora bedzie leczyc twoja druzyne\w^n^nAktualnie - [Leczy\y %dHP\r/\ysek\w przez\y %d sek\w]^nPo dodaniu punktu - [Bedzie leczyc\y %dHP\r/\ysek\w przez\y %d sek\w]^n^nPunkty umiejetnosci:\y %d\r /\y 4", gSkill[id][5] * 5, gSkill[id][5] * 5, (gSkill[id][5] + 1) * 5, (gSkill[id][5] + 1) * 5, gSkill[id][5]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKeyA[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "ARMenu");
}

public handleARMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][5] >= 4){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlARMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][5] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja aura zycia zostala ulepszona! Trwa teraz^x03 %d sekund^x01 oraz leczy^x03 %d HP^x01 na sekunde", gPrefix, gSkill[id][5] * 5, gSkill[id][5] * 5);
				WyswietlARMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Aure_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlPRMenu(id) 
{
	new MenuBody[1024], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Mozesz zeslac piorun na przeciwnika ktory go zrani\w^nWymagany poziom :\y 40\w^n^nWykupione - [%s\w]^n^nAktualnie zabiera - [\y%d%% Aktualnego HP\w]^nPo dodaniu zabierze - [\y%d%% Aktualnego HP\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", gSkill[id][4] ? "\yTak" : "\rNie", gSkill[id][4] * 10, (gSkill[id][4] + 1) * 10, gSkill[id][4]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n\r2. \wZbinduj pod klawisz [\yAktualne zbindowano pod :\w %s]", gBindKey[id]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<1)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "PRMenu");
}

public handlePRMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][4] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gLevel[id] < 40){
				ColorChat(id, GREEN, "%s^x01 Masz za niski poziom! (40 wymagany)", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlPRMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][4] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoje obrazenia piorunem wzrosly z^x03 %d%%^x01 do^x03 %d%%^x01 obrazen aktualnego hp", gPrefix, (gSkill[id][4] - 1) * 10, gSkill[id][4] * 10);
				WyswietlPRMenu(id);
				return 1;
			}
		}
		case 2:{
			client_cmd(id, "messagemode Zbinduj_Blyskawice_Na");
			client_cmd(id, "spk fvox/blip");
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlHPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod\w^n^nOpis umiejetnosci :\y Zwieksza Twoje maksymalne zycie\w^n^nAktualne zycie - [\y%d\w]^nZycie po dodaniu punktu - [\y%d\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", 100 + (gSkill[id][0] * 10), 100 + (gSkill[id][0] + 1) * 10, gSkill[id][0]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "HPMenu");
}

public handleHPMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][0] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlHPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][0] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoja witalnosc wzrosla z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill[id][0] - 1, gSkill[id][0]);
				WyswietlHPMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}

public WyswietlAPMenu(id) 
{
	new MenuBody[512], len, keys;
	
	len = format(MenuBody, sizeof MenuBody -1, "[uTabalugi]\y ExpMod^n^nOpis umiejetnosci :\y Zwieksza twoj maksymalny pancerz\w^n^nAktualny pancerz - [\y%d\w]^nPancerz po dodaniu punktu - [\y%d\w]^n^nPunkty umiejetnosci: \y%d\r /\y 5\w", gSkill[id][1] * 20, (gSkill[id][1] + 1) * 20, gSkill[id][1]);
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n^n\r1. \wDodaj punkt");
	len += format(MenuBody[len], sizeof MenuBody -1, "^n^n\r0. \wPowrot");
	
	keys = (1<<0)|(1<<9);
	
	show_menu(id, keys, MenuBody, -1, "APMenu");
}

public handleAPMenu(id, key){
	switch(key + 1){
		case 1:{
			if(gSkill[id][1] >= 5){
				ColorChat(id, GREEN, "%s^x01 Juz masz maksymalny poziom tej umiejetnosci!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			if(gPoint[id] < 1){
				ColorChat(id, GREEN, "%s^x01 Nie posiadasz punktow do rozdania!", gPrefix);
				WyswietlAPMenu(id);
				return 1;
			}
			else{
				gPoint[id] -= 1;
				gSkill[id][1] += 1;
				ColorChat(id, GREEN, "%s^x01 Sukces! Twoj pancerz wzrosl z poziomu^x03 %d^x01 na poziom^x03 %d", gPrefix, gSkill[id][1] - 1, gSkill[id][1]);
				WyswietlAPMenu(id);
				return 1;
			}
		}
		case 10: WyswietlSkillMenu(id);
		}
	
	return 1;
}
/*KONIEC MEN*/
/*STOCKI ORAZ ODPOWIEDNIKI DO KOMEND*/
public smashHead(pwned, pwnzor, Float:damage){
	//new id = pev(pwnzor, pev_owner);
	
	if(get_user_team(pwnzor) != get_user_team(pwned)){
		static Float:fOrigin[3], Float:Health;
		pev(pwned, pev_origin, fOrigin);	
		pev(pwned, pev_health,  Health);
		
		if(Health < damage){
			engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0);
			write_byte(TE_PARTICLEBURST);
			engfunc(EngFunc_WriteCoord, fOrigin[0]);
			engfunc(EngFunc_WriteCoord, fOrigin[1]);
			engfunc(EngFunc_WriteCoord, fOrigin[2]);
			write_short(50);
			write_byte(72);
			write_byte(10);
			message_end();
		}
		message_begin(MSG_ONE, gScreenShakeMsg, {0,0,0}, pwned);
		write_short(255<<14);
		write_short(10<<14);
		write_short(255<<14);
		message_end();
		
		engfunc(EngFunc_MessageBegin, MSG_BROADCAST, SVC_TEMPENTITY, fOrigin, 0);
		write_byte(TE_BLOODSPRITE);
		engfunc(EngFunc_WriteCoord, fOrigin[0] +  8.0);
		engfunc(EngFunc_WriteCoord, fOrigin[1]);
		engfunc(EngFunc_WriteCoord, fOrigin[2] + 26.0);
		write_short(sprite_bloodspray);
		write_short(sprite_blood);
		write_byte(248);
		write_byte(4);
		message_end();
		
		ExecuteHam(Ham_TakeDamage, pwned, "", pwnzor/*id*/, damage, 1);
	}
}

public writeHud(id){
	for (new id=0; id < 32; id++){
		if(is_user_connected(id) && is_user_alive(id)){
			new szText[150];
			
			if(gLevel[id] >= 65) 	format(szText, sizeof szText - 1,"Poziom: %d/65 Exp: %d Punkty: %d", gLevel[id], gXp[id], gPoint[id]);
			else 			format(szText, sizeof szText - 1, "Poziom: %d/65 Exp : %d/%d Punkty: %d", gLevel[id], gXp[id], gTable[gLevel[id]], gPoint[id]);
			
			
			message_begin(MSG_ONE, gStatusMsg, {0,0,0}, id);
			write_byte(0);
			write_string(szText);
			message_end();
		}
	}
}

public doReset(id){
	for (new i=0; i < ILOSC_SKILLI; i++){
		gSkill[id][i] = 0;
	}
	gPoint[id] = gLevel[id];
	ColorChat(id, GREEN, "%s^x01 Zresetowales statystyki!", gPrefix);
	
	return 1;
}

public cmdBind(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKey[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill" , gBindKey[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales blyskawice pod przycisk :^x03 %s", gPrefix, gBindKey[id]);
	
	WyswietlPRMenu(id);
}

public cmdBindA(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyA[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill2" , gBindKeyA[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales aure zycia pod przycisk :^x03 %s", gPrefix, gBindKeyA[id]);
	
	WyswietlARMenu(id);
}

public cmdBindST(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyS[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill3" , gBindKeyS[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales niewidzialnosc pod przycisk :^x03 %s", gPrefix, gBindKeyS[id]);
	
	WyswietlSTMenu(id);
}

public cmdBindK(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyK[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill4" , gBindKeyK[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales kamuflaz pod przycisk :^x03 %s", gPrefix, gBindKeyK[id]);
	
	WyswietlKMMenu(id);
}

public cmdBindP(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyP[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill5" , gBindKeyP[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales odepchniecie pod przycisk :^x03 %s", gPrefix, gBindKeyP[id]);
	
	WyswietlPHMenu(id);
}

public cmdBindPL(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyPL[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill6" , gBindKeyPL[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales pulapke pod przycisk :^x03 %s", gPrefix, gBindKeyPL[id]);
	
	WyswietlPLMenu(id);
}

public cmdBindOS(id){	
	new szKey[4];
	read_argv(1, szKey, 3);
	remove_quotes(szKey);
	
	gBindKeyOS[id] = szKey;
	
	client_cmd(id, "bind ^"%s^" +skill7" , gBindKeyOS[id]);
	
	ColorChat(id, GREEN, "%s^x01 Zbindowales oslepienie pod przycisk :^x03 %s", gPrefix, gBindKeyOS[id]);
	
	WyswietlOSMenu(id);
}

public openMenu(id){
	WyswietlMainMenu(id);
	return 1;
}

public trySpawn(id){
	if(!gSkill[id][3]) return;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= (gSkill[id][3] * 4)){
		//ExecuteHamB(Ham_CS_RoundRespawn, id);
		set_task(1.0,"respawn_player",id);
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Udalo Ci sie odrodzic!", gPrefix);
	}
}

public respawn_player(id)
{     
if (!is_user_connected(id) || is_user_alive(id) || cs_get_user_team(id) == CS_TEAM_SPECTATOR||g_end==1)         return;

ExecuteHamB(Ham_CS_RoundRespawn, id);
	
if (is_user_bot(id) && pev(id, pev_deadflag) == DEAD_RESPAWNABLE)
{
	dllfunc(DLLFunc_Spawn, id);
}
}

public tryKar(id){
	id -= TASK_KAR;
	if(!gSkill[id][15]) return 1;
	if(!is_user_alive(id)) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][15] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
			case 1:{
				fm_give_item(id, "weapon_m4a1");
				cs_set_user_bpammo(id, CSW_M4A1, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_m4a1", id ), 1);
			}
			case 2:{
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
			case 3:{
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
			case 4:{
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales zestaw broni!", gPrefix);
	}
	return 0;
}

public tryZes(id){
	id -= TASK_KAR;
	if(!gSkill[id][18]) return 1;
	if(!is_user_alive(id)) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][18] * 5){
		new random_weapon = random_num(1, 4);
		switch(random_weapon){
			case 1:{
				fm_give_item(id, "weapon_deagle");
				fm_give_item(id, "weapon_m4a1");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_user_bpammo(id, CSW_M4A1, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_m4a1", id ), 1);
			}
			case 2:{
				fm_give_item(id, "weapon_usp");
				fm_give_item(id, "weapon_ak47");
				cs_set_user_bpammo(id, CSW_AK47, 0);
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_ak47", id ), 1);
			}
			case 3:{
				fm_give_item(id, "weapon_p228");
				fm_give_item(id, "weapon_tmp");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_user_bpammo(id, CSW_TMP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_tmp", id ), 1);
			}
			case 4:{
				fm_give_item(id, "weapon_elite");
				fm_give_item(id, "weapon_mac10");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_user_bpammo(id, CSW_MAC10, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_mac10", id ), 1);
			}
		}
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales karabin!", gPrefix);
	}
	return 0;
}

public tryGun(id){
	id -= TASK_GUN;
	if(!gSkill[id][8]) return 1;
	if(!is_user_alive(id)) return 1;
	new random_numODP	= 	random_num(1, 100);
	
	if(random_numODP <= gSkill[id][8] * 5){
		new random_weapon = random_num(1, 5);
		switch(random_weapon){
			case 1:{
				fm_give_item(id, "weapon_deagle");
				cs_set_user_bpammo(id, CSW_DEAGLE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_deagle", id ), 1);
			}
			case 2:{
				fm_give_item(id, "weapon_glock18");
				cs_set_user_bpammo(id, CSW_GLOCK18, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_glock18", id ), 1);
			}
			case 3:{
				fm_give_item(id, "weapon_p228");
				cs_set_user_bpammo(id, CSW_P228, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_p228", id ), 1);
			}
			case 4:{
				fm_give_item(id, "weapon_usp");
				cs_set_user_bpammo(id, CSW_USP, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_usp", id ), 1);
			}
			case 5:{
				fm_give_item(id, "weapon_elite");
				cs_set_user_bpammo(id, CSW_ELITE, 0);
				cs_set_weapon_ammo(find_ent_by_owner(1, "weapon_elite", id ), 1);
			}
		}
		ColorChat(id, GREEN, "%s^x01 Gratulacje! Wylosowales pistolet%s!", gPrefix, random_weapon == 5 ? "y" : "");
	}
	return 0;
}

public doAura(id){
	if(!gSkill[id][5]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][1]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	new Float:mins[3], Float:maxs[3];
	
	mins = Float:{-64.0, -64.0, -64.0};
	maxs = Float:{64.0, 64.0, 64.0};
	
	pev(id, pev_origin, gfOrigin);
	
	new ent = engfunc(EngFunc_CreateNamedEntity, engfunc( EngFunc_AllocString, "info_target"));
	
	engfunc(EngFunc_SetModel, ent, gAuraModel) ;
	engfunc(EngFunc_SetSize, ent, mins, maxs);
	engfunc(EngFunc_SetOrigin, ent, gfOrigin);
	set_pev(ent, pev_solid, SOLID_TRIGGER);
	set_pev(ent, pev_movetype, MOVETYPE_NONE);
	set_pev(ent, pev_classname, gAuraClassname);
	set_pev(ent, pev_owner, id);
	
	switch(get_user_team(id)){
		case 1: set_rendering(ent, kRenderFxGlowShell, 255, 0, 0, kRenderTransAlpha, 35);
			case 2: set_rendering(ent, kRenderFxGlowShell, 0, 32, 255, kRenderTransAlpha, 35);
		}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	//set_task(float(gSkill[id][5] * 5), "taskAuraRemove", ent, _, _, "a", 1);
	set_task(float(gSkill[id][5] * 5),"usunent",ent);
	
	ColorChat(id, GREEN, "%s^x01 Postawiles aure^x03 [%dHP / sekunde^x01 stac bedzie :^x03 %d sekund]", gPrefix, gSkill[id][5] * 5, gSkill[id][5] * 5);
	gUsed[id][1] = true;
	return 0;
} 

/*public taskAuraRemove(ent){
	while((ent = fm_find_ent_by_class(ent, gAuraClassname)))
		engfunc(EngFunc_RemoveEntity, ent);
}*/
public usunent(ent)
{
	if(is_valid_ent(ent))
	{
		remove_entity(ent);
	}
}

public FW_FM_AuraThink(ent)
{
	if(!pev_valid(ent))
		return 0;
	
	static iPlayers[32], iNum;
	get_players(iPlayers, iNum, "a");
	static i;
	new owner = pev(ent, pev_owner);
	for(i = 0 ; i < iNum; i++)
	{	
		new Float: Health
		pev(iPlayers[i], pev_health, Health);
		if(entity_range(iPlayers[i], ent) <= 100.0 && get_user_team(owner) == get_user_team(iPlayers[i])){
			if(Health >= (100 + (gSkill[iPlayers[i]][0] * 10))){
				set_pev(iPlayers[i], pev_health, 100 + (gSkill[owner][0] * 5.0));
			}
			else{
				set_pev(iPlayers[i], pev_health, Health + gSkill[owner][5] * 5.0);
				message_begin(MSG_ONE, gScreenFadeMsg, {0,0,0}, iPlayers[i]);
				write_short((1<<12));
				write_short((1<<8));
				write_short(0x0000);
				write_byte(255);
				write_byte(0);
				write_byte(64);
				write_byte(64);
				message_end();
			}
		}
	}
	
	set_pev(ent, pev_nextthink, get_gametime() + 1.0);
	
	return 0;
}

public doStealth(id){
	if(!gSkill[id][6]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][2]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	if(task_exists(id + TASK_STEALTH)) remove_task(id + TASK_STEALTH);
	
	set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderTransColor, 0);
	
	gfTime[id][0] = float((gSkill[id][6] * 2))
	set_task(0.1, "Stealth_Countdown", id + TASK_STEALTH, "", _, "a", (gSkill[id][6] * 2) * 10);
	
	gUsed[id][2] = true;
	
	return 0;
}

public Stealth_Countdown(id){
	id -= TASK_STEALTH;
	
	if(gfTime[id][0] <= 0.3)
		set_rendering(id, kRenderFxGlowShell, 0, 0, 0, kRenderNormal, 255);
		
	gfTime[id][0] -= 0.1;
	set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 0.1, 0.2, 0.1, 0.1, 3);
	show_hudmessage(id, "[uTabalugi] Niewidzialnosc : %.1f", gfTime[id][0])
}

public doKamuflaz(id){
	if(!gSkill[id][7]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][3]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	gfTime[id][1] = float(((5 * gSkill[id][7]) + gSkill[id][20]));
	set_task(0.1, "Kamuflaz_Countdown", id + TASK_KAMUFLAZ, "", _, "a", ((gSkill[id][7] * 5) + gSkill[id][20]) * 10);
	
	/*new szModel[32];
	
	cs_get_user_model(id, szModel, sizeof szModel - 1);
	
	gCamouflageOldModel[id] = szModel;*/
	
	switch(get_user_team(id)){
		case 1:	cs_set_user_model(id, "urban");
			case 2:	cs_set_user_model(id, "leet");
		}
	
	gUsed[id][3] = true;
	
	return 1;
}

public Kamuflaz_Countdown(id){
	id -= TASK_KAMUFLAZ;
	
	if(gfTime[id][1] <= 0.3)
		cs_reset_user_model(id);
	
	gfTime[id][1] -= 0.1;
	set_hudmessage(127, 255, 85, 0.01, 0.54, 0, 0.1, 0.2, 0.1, 0.1, 2);
	show_hudmessage(id, "^n[uTabalugi] Kamuflaz : %.1f", gfTime[id][1]);
}

fm_add_user_armor(id, Float:amount, type){
	set_pev(id, pev_armorvalue, amount);
	set_pdata_int(id, 112, type);
	
	if (type){
		message_begin(MSG_ONE_UNRELIABLE , gArmorMsg , _ , id);
		write_byte(type == 2 ? 1 : 0);
		message_end();
	}
} 

/*fm_respawnplayer(id){
	set_pev(id, pev_deadflag, DEAD_RESPAWNABLE);
	dllfunc(DLLFunc_Think, id);
	dllfunc(DLLFunc_Spawn, id);
}*/

Thunder(start[3], end[3]){			
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY ); 
	write_byte(TE_BEAMPOINTS); 
	write_coord(start[0]); 
	write_coord(start[1]); 
	write_coord(start[2]); 
	write_coord(end[0]); 
	write_coord(end[1]); 
	write_coord(end[2]); 
	write_short(sprite_lightning); 
	write_byte(1);
	write_byte(5);
	write_byte(7);
	write_byte(20);
	write_byte(30);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	write_byte(200);
	message_end();
	
	message_begin(MSG_PVS, SVC_TEMPENTITY, end);
	write_byte(TE_SPARKS);
	write_coord(end[0]);
	write_coord(end[1]);
	write_coord(end[2]);
	message_end();
	
	emit_sound(0 ,CHAN_ITEM, gThunderSound, 1.0, ATTN_NORM, 0, PITCH_NORM);
}

makeScreenFade(id, Float:fDuration, Float:fHoldtime, red, green, blue, alpha)
{
	message_begin(MSG_ONE, gScreenFadeMsg, {0, 0, 0}, id);
	write_short(floatround(4096.0 * fDuration, floatround_round));
	write_short(floatround(4096.0 * fHoldtime, floatround_round));
	write_short(4096);
	write_byte(red);
	write_byte(green);
	write_byte(blue);
	write_byte(alpha);
	message_end();
	
	return 1;
}

Smoke(iorigin[3], scale, framerate){
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
	write_byte(TE_SMOKE);
	write_coord(iorigin[0]);
	write_coord(iorigin[1]);
	write_coord(iorigin[2]);
	write_short(sprite_smoke);
	write_byte(scale);
	write_byte(framerate);
	message_end();
}

stock get_velocity_from_origin( ent, Float:fOrigin[3], Float:fSpeed, Float:fVelocity[3] ){
	new Float:fEntOrigin[3];
	entity_get_vector(ent, EV_VEC_origin, fEntOrigin);
	
	new Float:fDistance[3];
	fDistance[0] = fEntOrigin[0] - fOrigin[0];
	fDistance[1] = fEntOrigin[1] - fOrigin[1];
	fDistance[2] = fEntOrigin[2] - fOrigin[2];
	
	new Float:fTime = ( vector_distance( fEntOrigin,fOrigin) / fSpeed);
	
	fVelocity[0] = fDistance[0] / fTime;
	fVelocity[1] = fDistance[1] / fTime;
	fVelocity[2] = fDistance[2] / fTime;
	
	return (fVelocity[0] && fVelocity[1] && fVelocity[2]);
}

stock set_velocity_from_origin(ent, Float:fOrigin[3], Float:fSpeed){
	new Float:fVelocity[3];
	get_velocity_from_origin(ent, fOrigin, fSpeed, fVelocity);
	
	entity_set_vector(ent, EV_VEC_velocity, fVelocity);
	
	return (1);
}

public doPush(id){
	if(!gSkill[id][10]){
		ColorChat(id, GREEN, "%s^x01 Nie masz wykupionej tej umiejetnosci", gPrefix);
		return 1;
	}
	if(gUsed[id][4]){
		ColorChat(id, GREEN, "%s^x01 Juz raz tego uzyles", gPrefix);
		return 1;
	}
	if(!is_user_alive(id)){
		ColorChat(id, GREEN, "%s^x01 Musisz byc zywy aby tego uzyc", gPrefix);
		return 1;
	}
	
	static iPlayers[32], iNum, i;
	get_players(iPlayers, iNum, "a");
	
	for(i = 0 ; i < iNum; i++)
	{	
		new vOrigin2[3];
		get_user_origin(id, vOrigin2);
		//MES #4
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
		write_byte(21);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2]);
		write_coord(vOrigin2[0]);
		write_coord(vOrigin2[1]);
		write_coord(vOrigin2[2] + (gSkill[id][10] * 50));
		write_short(sprite_push);
		write_byte(0);
		write_byte(0);
		write_byte(5);
		write_byte(64);
		write_byte(0);
		write_byte(128);
		write_byte(128);
		write_byte(135);
		write_byte(128);
		write_byte(0);
		message_end();
		
		emit_sound(id ,CHAN_ITEM, gPushSound, 1.0, ATTN_NORM, 0,PITCH_NORM);
		
		if(entity_range(iPlayers[i], id) <= float(gSkill[id][10] * 40) && get_user_team(id) != get_user_team(iPlayers[i])){
			new Float:fOrigin[2][3], vOrigin[3], b, flags;
			entity_get_vector(iPlayers[i], EV_VEC_origin, fOrigin[1]);
			entity_get_vector(id, EV_VEC_origin, fOrigin[0]);
			get_user_origin(iPlayers[i], vOrigin);
			flags = entity_get_int(iPlayers[i], EV_INT_flags);
			
			//PETLA na 2 originy
			for (b = 0;b <= 2 ; b ++) 
			{
				fOrigin[1][b] -= fOrigin[0][b];
				
				if (flags & FL_ONGROUND)
					fOrigin[1][b] *= (float(gSkill[id][10]) * 4.0);
				
				else
					fOrigin[1][b] *= (float(gSkill[id][10]) * 1.5);
			}
			
			//MES #0
			Smoke(vOrigin, 10, 10);
			
			//MES #1
			message_begin(MSG_BROADCAST, SVC_TEMPENTITY);
			write_byte(TE_IMPLOSION);
			write_coord(vOrigin[0]);
			write_coord(vOrigin[1]);
			write_coord(vOrigin[2]);
			write_byte(80);
			write_byte(10);
			write_byte(10); 
			message_end();
			
			//MES #2
			engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, fOrigin, 0);
			write_byte(TE_PARTICLEBURST);
			engfunc(EngFunc_WriteCoord, fOrigin[0][0]);
			engfunc(EngFunc_WriteCoord, fOrigin[0][1]);
			engfunc(EngFunc_WriteCoord, fOrigin[0][2]);
			write_short(50);
			write_byte(235);
			write_byte(10);
			message_end();
			
			//MES #3
			message_begin(MSG_ONE, gScreenShakeMsg, {0,0,0}, iPlayers[i]);
			write_short(255<< 14 );
			write_short(10 << 14);
			write_short(255<< 14);
			message_end();
			
			//GLOWNY ACTION
			entity_set_vector(iPlayers[i], EV_VEC_velocity, fOrigin[1]);
		}
	}
	gUsed[id][4] = true;
	
	return 0;
}

addExp(id, num){
	gXp[id] += num;
	
	refreshExp(id);
}

refreshExp(id){
	while(gXp[id] >= gTable[gLevel[id]]){
		gLevel[id] += 1;
		gPoint[id] += 1;
		new szPlayerName[32];
		get_user_name(id, szPlayerName, 32);
		ColorChat(0, GREEN,"%s^x01 Gracz^x03 %s^x01 awansowal na^x04 %d^x01 poziom", gPrefix, szPlayerName, gLevel[id]);
	}
}

public showIt(){
	new iPlayers[32], iNum;
	get_players(iPlayers, iNum, "ac");
	
	for(new i ; i < iNum; i++){
		new ent, body;
		get_user_aiming(iPlayers[i], ent, body);
		
		if(IsPlayer(ent) && is_user_alive(ent)){
			new szName[32];
			get_user_name(ent, szName, sizeof szName - 1);
			
			set_hudmessage(get_user_team(ent) == 2 ? 0 : 255, get_user_team(ent) == 2 ? 128 : 64, get_user_team(ent) == 2 ? 255 : 0,
			0.36, 0.55, 0, 0.1, 0.1, 0.4, 0.4, 4);
			
			show_hudmessage(iPlayers[i], "Gracz: %s^nPoziom: %d", szName, gLevel[ent]);
		}
	}
}

public Save(id){
	new NameID[32]; 
	get_user_name(id, 	NameID, 		32); 
	
	new vaultkey[64], 	vaultdata[256]; 
	format(vaultkey, 	63, "%s-PLAYER", 	NameID); 
	format(vaultdata,	255, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#", gXp[id], gLevel[id], gPoint[id], gSkill[id][0], gSkill[id][1], gSkill[id][2], gSkill[id][3], gSkill[id][4], gSkill[id][5], gSkill[id][6],
	gSkill[id][7], gSkill[id][8], gSkill[id][9], gSkill[id][10], gSkill[id][11], gSkill[id][13], gSkill[id][14], gSkill[id][15], gSkill[id][16],
	gSkill[id][17], gSkill[id][18], gSkill[id][19], gSkill[id][20]);
	
	nvault_set(gVaultFile, vaultkey, 		vaultdata); 
	
	return 0;
}

public Load(id){
	new 	NameID[32]; 
	get_user_name(id, 	NameID, 	32); 
	
	new vaultkey[64], 	vaultdata[256]; 
	format(vaultkey, 	63, "%s-PLAYER", 	NameID); 
	format(vaultdata,	255, "%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#%d#", gXp[id], gLevel[id], gPoint[id], gSkill[id][0], gSkill[id][1], gSkill[id][2], gSkill[id][3], gSkill[id][4], gSkill[id][5], gSkill[id][6],
	gSkill[id][7], gSkill[id][8], gSkill[id][9], gSkill[id][10], gSkill[id][11], gSkill[id][13], gSkill[id][14], gSkill[id][15], gSkill[id][16],
	gSkill[id][17], gSkill[id][18], gSkill[id][19], gSkill[id][20]);
	
	nvault_get(gVaultFile, vaultkey, 		vaultdata,	255); 
	
	replace_all(vaultdata, 255, "#", 	" "); 
	
	new 	gxp[32],
		glvl[32],
		gpt[32],
		skill0[32],
		skill1[32],
		skill2[32],
		skill3[32],
		skill4[32],
		skill5[32],
		skill6[32],
		skill7[32],
		skill8[32],
		skill9[32],
		skill10[32],
		skill11[32],
		skill13[32],
		skill14[32],
		skill15[32],
		skill16[32],
		skill17[32],
		skill18[32],
		skill19[32],
		skill20[32];
		
	
	parse(vaultdata, gxp, 31, glvl, 31, gpt, 31, skill0, 31, skill1, 31, skill2, 31, skill3, 31, skill4, 31, skill5, 31, skill6, 31, skill7, 31, skill8, 31, skill9, 31, skill10, 31, skill11, 31, skill13, 31,
	skill14, 31, skill15, 31, skill16, 31, skill17, 31, skill18, 31, skill19, 31, skill20, 31);
	
	
	gXp[id]		=	str_to_num(gxp);
	gLevel[id]	=	str_to_num(glvl);
	gPoint[id]	=	str_to_num(gpt);
	gSkill[id][0] 	= 	str_to_num(skill0);
	gSkill[id][1] 	= 	str_to_num(skill1);
	gSkill[id][2] 	= 	str_to_num(skill2);
	gSkill[id][3] 	= 	str_to_num(skill3);
	gSkill[id][4] 	= 	str_to_num(skill4);
	gSkill[id][5] 	= 	str_to_num(skill5);
	gSkill[id][6] 	= 	str_to_num(skill6);
	gSkill[id][7] 	= 	str_to_num(skill7);
	gSkill[id][8] 	= 	str_to_num(skill8);
	gSkill[id][9] 	= 	str_to_num(skill9);
	gSkill[id][10] 	= 	str_to_num(skill10);
	gSkill[id][11] 	= 	str_to_num(skill11);
	gSkill[id][13] 	= 	str_to_num(skill13);
	gSkill[id][14] 	= 	str_to_num(skill14);
	gSkill[id][15] 	= 	str_to_num(skill15);
	gSkill[id][16] 	= 	str_to_num(skill16);
	gSkill[id][17] 	= 	str_to_num(skill17);
	gSkill[id][18] 	= 	str_to_num(skill18);
	gSkill[id][19] 	= 	str_to_num(skill19);
	gSkill[id][20] 	= 	str_to_num(skill20);
	
	return 0;
}

stock is_alowed_server(const gServerIp[])
{
	new ip[22];
	get_user_ip(0, ip, sizeof ip - 1);
	
	if(!equal(gServerIp, ip))
		set_fail_state("-><-");
}

public _get_xp(plugin, params)
{
	return gXp[get_param(1)];
}

public _set_xp(plugin, params)
{
	new client = get_param(1);
	gXp[client] = max(0, get_param(2));
	refreshExp(client);
	return gXp[client];
}

public message()
{
	new arg[32]
	get_msg_arg_string(2, arg, 31)
	if(containi(arg,"name")!=-1)
	{
		return PLUGIN_HANDLED
	}
	return PLUGIN_CONTINUE
}

public client_infochanged(id)
{
    new newname[32],oldname[32]
    get_user_info(id, "name", newname,31)
    get_user_name(id,oldname,31)
    if(!is_user_connected(id) || is_user_bot(id)) return PLUGIN_CONTINUE
    if(!equali(newname, oldname))
    {
        set_user_info(id,"name",oldname)
        ColorChat(id, GREEN, "%s^x01 Zakaz zmiany nicka!", gPrefix);
        return PLUGIN_HANDLED
    }
    return PLUGIN_CONTINUE
}

public NajlepszyGracz()
{
	new high;		
	for(new id = 0; id < get_maxplayers(); id++) 
	{
		if(!is_user_connected(high) || (is_user_connected(id) && gXp[id] > gXp[high])) 
		{
			high= id;
		}
	}
	if(is_user_connected(high))
	{
		new gszName[33];
		get_user_name(high, gszName, charsmax(gszName));
		ColorChat(0, GREEN, "%s^x01 Najlepszym graczem na serwerze jest^x03 %s^x01 (Poziom:^x04 %d^x01 Exp:^x04 %d^x01)", gPrefix, gszName, gLevel[high], gXp[high]);
	}
}
public cmdShowTop15(id)
{
	static Sort[33][2];
	new players[32],num,count,index;
	get_players(players,num);
    
	for(new i = 0; i < num; i++)
	{
		index = players[i];
		Sort[count][0] = index;
		Sort[count][1] = gLevel[index];
		count++;
	}
    
	SortCustom2D(Sort,count,"CompareXp");
	new motd[1501],iLen;
	iLen = formatex(motd, sizeof motd - 1,"<body bgcolor=#000000><font color=#98f5ff><pre>");
	iLen += formatex(motd[iLen], (sizeof motd - 1) - iLen,"%s %-22.22s %3s^n", "#", "Name", "# Poziom");
    
	new y = clamp(count, 0, 15);
	new name[32],kindex;
    
	for(new x = 0; x < y; x++)
	{
		kindex = Sort[x][0];
		get_user_name(kindex,name,sizeof name - 1);
		iLen += formatex(motd[iLen], (sizeof motd - 1) - iLen,"%d %-22.22s %d^n", x + 1, name, Sort[x][1]);
	}
	iLen += formatex(motd[iLen], (sizeof motd - 1) - iLen,"</body></font></pre>");
	show_motd(id,motd, "Top 15 ExpMod");
}
public CompareXp(elem1[], elem2[])
{
	if(elem1[1] > elem2[1])
		return -1;
	else if(elem1[1] < elem2[1])
		return 1;
    
	return 0;
} 
public messageScoreAttrib(iMsgID, iDest, iReceiver) 
{   
        new iPlayer = get_msg_arg_int(1);
        
        if(is_user_connected(iPlayer) && (get_user_flags(iPlayer) & VIP_FLAG))   
                set_msg_arg_int(2, ARG_BYTE, is_user_alive(iPlayer) ? SCOREATTRIB_VIP : SCOREATTRIB_DEAD);
        
}
public cmdShowVipsOnline( id )
{
	new gMessage[ 256 ], gSizeMessage = 0, gSizeOfVips = 0;

	gSizeMessage = format( gMessage, ( sizeof gMessage - 1 ), "%s Vipy Na Serwerze:", gPrefix );
	
	for( new player = 1; player < get_maxplayers( ); player ++ ) 
	{
		if( 0 > player > get_maxplayers( ) ) 
			continue;
		
		if( get_user_flags( player ) & ADMIN_RESERVATION ) 
		{
			new gszVipName[ 64 ];
			get_user_name( player, gszVipName, charsmax( gszVipName ) );
			
			gSizeMessage += format( gMessage[ gSizeMessage ], ( sizeof gMessage - 1 ) - gSizeMessage, " %s |", gszVipName );
			
			gSizeOfVips ++;
			
		}
	}
	
	if( gSizeOfVips == 0 )
	{
		gSizeMessage = format( gMessage[ gSizeMessage ], ( sizeof gMessage - 1 ) - gSizeMessage, "%s Brak vipow na serwerze", gPrefix );
	}
	
	
	client_print( id, print_chat, gMessage );
	
	return PLUGIN_HANDLED;
}
